<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.handoverstandard_delete"
                   @click="handleDelete">刪 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, getCodeList} from "@/api/bank/handoverstandard";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "業務流程",
              prop: "codeName",
              type: "select",
              hide: true,
              editDisplay: false,
              viewDisplay: false,
              dicData: [],
              rules: [{
                required: true,
                message: "請輸入業務流程",
                trigger: "blur"
              }]
            },
            {
              label: "業務流程",
              prop: "code",
              type: "select",
              addDisplay: false,
              disabled: true,
              dicData: [
                {
                  label: "網點鎖匙/密碼/實物交接登記表", value: "keypwd"
                },
                {
                  label: "業務印章交接登記表", value: "sealhandover"
                },
                {
                  label: "網點出納主管及專管員崗位變更記錄表", value: "postchange"
                },
                {
                  label: "查庫流水帳記錄表", value: "checkwarehouse"
                },
                {
                  label: "核對記錄表（每日）", value: "checklist_day"
                },
                {
                  label: "核對記錄表（每週）", value: "checklist_week"
                },
                {
                  label: "核對記錄表（每月）", value: "checklist_month"
                },
                {
                  label: "櫃員尾箱檢查流水帳記錄表", value: "tellertrunk"
                },
                {
                  label: "使用及出入庫登記表", value: "goodsuse"
                },
                {
                  label: "新開戶退件登記表", value: "returns"
                },
                {
                  label: "自助設備吞卡資料", value: "cardswallow"
                },
                {
                  label: "信息發佈", value: "message"
                },
              ],
              rules: [{
                required: true,
                message: "請輸入業務流程",
                trigger: "blur"
              }]
            },
            {
              label: "注意事項內容",
              prop: "content",
              type: "textarea",
              span: 24,
              rules: [{
                required: true,
                message: "請輸入注意事項內容",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.handoverstandard_add, false),
          viewBtn: this.vaildData(this.permission.handoverstandard_view, false),
          delBtn: this.vaildData(this.permission.handoverstandard_delete, false),
          editBtn: this.vaildData(this.permission.handoverstandard_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    mounted() {
      let dicData = [
        {
          label: "網點鎖匙/密碼/實物交接登記表", value: "keypwd"
        },
        {
          label: "業務印章交接登記表", value: "sealhandover"
        },
        {
          label: "網點出納主管及專管員崗位變更記錄表", value: "postchange"
        },
        {
          label: "查庫流水帳記錄表", value: "checkwarehouse"
        },
        {
          label: "核對記錄表（每日）", value: "checklist_day"
        },
        {
          label: "核對記錄表（每週）", value: "checklist_week"
        },
        {
          label: "核對記錄表（每月）", value: "checklist_month"
        },
        {
          label: "櫃員尾箱檢查流水帳記錄表", value: "tellertrunk"
        },
        {
          label: "使用及出入庫登記表", value: "goodsuse"
        },
        {
          label: "新開戶退件登記表", value: "returns"
        },
        {
          label: "自助設備吞卡資料", value: "cardswallow"
        },
        {
          label: "信息發佈", value: "message"
        },
      ];
      getCodeList().then(res => {
        const data = res.data.data;
        let dicArr = [];
        if (data){
          let codeStr = data.join();
          codeStr += ',';
          dicData.forEach(item => {
            if (codeStr.indexOf(item.value + ',') == -1){
              dicArr.push(item);
            }
          })
          this.findObject(this.option.column, 'codeName').dicData = dicArr;
        }
      });
    },
    methods: {
      rowSave(row, done, loading) {
        row.code = row.codeName;
        add(row).then(() => {
          let arr = this.findObject(this.option.column, 'codeName').dicData;
          for (let i = 0; i < arr.length; i++) {
            let item = arr[i];
            if (item.value == row.code){
              arr.splice(i,1)
              break;
            }
          }
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        if (row.codeName && !row.code){
          row.code = row.codeName;
        }
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
